;	@com.wudsn.ide.asm.mainsourcefile=ST-NICCC-Blitter.asm

	.if .not .def VBXE_BASE
	VBXE_BASE = $d600
	.endif

	.if 1 = 0
scene_version	= 1
scene_file_size = .FILESIZE('ST-ONT-Scene.bin')
	.macro m_ins
	.echo "Inserting scene segment starting at ",:1, " with ", :2, " bytes"
	ins 'ST-ONT-Scene.bin',:1,:2
	.endm

	.else
scene_version = 2
scene_file_size = .FILESIZE('ST-NICCC-Scene.bin')
	.macro m_ins
	ins 'ST-NICCC-Scene.bin',:1,:2
	.endm

	.endif
scene_16k_banks	= scene_file_size/$4000	
	.print "Using ", scene_16k_banks, " 16k banks for scene file with ",scene_file_size, " bytes"

	icl "System-Equates.asm"
	icl "VBXE-Equates.asm"

vbxe_core_version_offset = $40

portb_banks_count	equ $1f00
portb_banks		equ $1f01
portb_bank_address	equ $4000

.if standalone = 0			;ROM case, one bank is $2000 bytes, bank 0 is loader
vbxe_window		equ $4000	;because $4000-$7fff is used by PORTB memory banks
vbxe_bank_d600		equ 1		;Bank 1 for $d600
vbxe_bank_d700		equ 2		;Bank 2 for $d700
stream_bank		equ 3
stream_data		equ $a000
stream_end		equ $c000
.elseif standalone = 1		;XEX case, one bank is $4000 bytes, loader needs no bank
vbxe_window		equ $8000	;because $a000-$bfff is used by the cartidge banks
vbxe_bank_d600		equ 0		;Bank 0 for $d600
vbxe_bank_d700		equ 0		;Bank 0 for $d700
stream_bank		equ 1
stream_data		equ $4000
stream_end		equ $8000
.endif

demo			equ $2000

	.macro m_version
	.byte $00,$0a,$0d
	.byte 'ST-NICCC 2000 REMAKE BY HEAVEN'
	.byte $00,$0a,$0d
	.byte 'FINAL VERSION BY JAC!'
	.byte $00,$0a,$0d
	.byte 'BUILD 2022-06-27'
	.byte $00,$0a,$0d
	.endm

	.macro m_align_2_pages	;Fills with 0 and prints how much space is "lost"
	here = *
	size = [[[here+$200-1]/$200]*$200]-*
	.print "Alignment added at ",here,": ", size, " bytes."
	.rept size
	.byte 0
	.endr
	.endm

	.macro m_align_8k	;Fills with 0 and prints how much space is "lost"
	here = *
	size = [[[here+$2000-1]/$2000]*$2000]-*
	.print "Alignment added at ",here,": ", size, " bytes."
	.rept size
	.byte 0
	.endr
	.endm