* ;bb5c bfcb	



music_flag=0
stereomode=1
standalone=0
blitter_only=0

.if standalone=0
	opt f+
.else
	opt f-
.endif

;lerp
;berechne dein x und y f�r z und z+1
;[13:06:57] axis/oxyron: und benutz die 8 bit hinterm komma von z als lerp zwischen den beiden
;[13:07:05] axis/oxyron: dann haste ne echt 16 bit pipeline
;x1=x*ztab[zhi]
;x2=x*ztab[zhi+1]
;x�=x1+(x2-x1)*zlo

;xstep=(dy<<8/)dx
;{
;  x=x1>>8
;  x1=x1+xstep
;}
;prestep=dx*y1_l
;nur 1 mal pro edge
;[15:57:27] axis/oxyron: y1=y1+prestep

;x
;y mal M = x*m11+y*m21+z*m31+y*m12+y*m22+z*m32+z*m13+y*23+y*m33
;z


;                       VBXE summary
;
; $D640   video control bit0 - xdl enable
;                       bit1 - enable 256 colors for GTIA instead of 128
;                       bit2 - disable transparency for color 0
;                       bit3 - enable color $xF being transparent
; $D641-3 XDL address low/mid/high
; $D644   MSEL write $Cx to update palette x (after MB0), write $80 to
; $D645   MB0 write colr index (after RGB) \               update 
; $D646   MB1 write R component             \             priority
; $D647   MB2 write G component              \             definitions
; $D648   MB3 write B component               \
; $D649   colmask - mask applied to overlay color for collision detection
; $D64A   colclr - resets coldetect
;       read = coldetect - bits correspond to GTIA colors that have collided
;                          with an overlay color
; $D64C   ma-cpu   \ bit 7 enables VRAM window at $2000-$3FFF
; $D64D   ma-antic / bits 0-5 select bank
; $D64E   mb-cpu   \ bit 7 enables VRAM window at $4000-$7FFF
; $D64F   mb-antic / bits 0-4 select bank
; $D650-2 blitter address
;       read $D650 = collision code >0 pixel value that was overwritten
; $D653   blitter start - write 1 to start, write 0 to stop
;       read = blitter busy (busy when non-zero)
; $D654   IRQ control - bit 0 enables blitter done IRQ
;
; XDL 
; byte 0
;   bit 0 - set to enable text mode
;   bit 1 - set to enable gfx mode
;   bit 2 - set to disable overlay
;   bit 3 - set to enable color attributes
;   bit 4 - set to disable color attributes
;   bit 5 - RPTL
;   bit 6 - OVADR
;   bit 7 - OVSCRL
; byte 1
;   bit 0 - CHBASE
;   bit 1 - MAPADR (color attributes)
;   bit 2 - MAPPAR (color attributes)
;   bit 3 - OVATT
;   bit 4 - enable hi-res mode (640)
;   bit 5 - enable low-res mode (160)
;   bit 6 - reserved
;   bit 7 - end of XDL, wait for VBLANK

; RPTL - number of scanlines-1 for this modeline
; OVADR - 3 bytes overlay address, 2 bytes line step size
; OVSCRL - 1 byte hscroll, 1 byte vscroll
; CHBASE - high byte of charset address
; MAPADR - 3 bytes map address, 2 bytes line step size
; MAPPAR - 1b hscroll, 1b vscroll, 1b cell width-1, 1b cell height-1
; OVATT - byte 1 - overlay width and color shift
;         byte 2 - priority bits - bit0 - overlay above PM0
;                                  bit1 - ... PM1
;                                  bit2 - ... PM2
;                                  bit3 - ... PM3
;                                  bit4 - ... PF0
;                                  bit5 - ... PF1
;                                  bit6 - ... PF2
;                                  bit7 - ... PF3
; attributes map format
; byte 0 - colpf0 substitute color
; byte 1 - colpf1
; byte 2 - colpf2
; byte 3 - bits 0-1 - priority setting select
;          bit 2 - resolution override
;          bit 3 - reserved
;          bits 4-5 - overlay palette select
;          bits 6-7 - GTIA palette select
;
; Blitter Command Block
; bytes 0-2 source addr
; bytes 3-4 source line step
; bytes 5-7 dest. addr
; bytes 8-9 dest. line step
; bytes 10-11 obj width-1 in bytes
; byte 12 obj height
; byte 13 source AND mask
; byte 14 source XOR mask
; byte 15 collision AND mask
; byte 16 zoom bits 0-2 - x zoom
;              bit 3 - increment by 2 if set, else increment by 1
;              bits 4-6 - y zoom
; byte 17 pattern - bit 7 enables repeating source data horizontally
;                   bits 0-5 pattern width       
; byte 18 control - bits 0-2 - MODE
;                   bit3 - NEXT - 0 for last BCB
;                   bit4 - source x decrement if set, else increment
;                   bit5 - source y
;                   bit6 - dest. x
;                   bit7 - dest. y
; mode 0 - copy opaque
; mode 1 - copy with transparency
; mode 2 - source added to dest.
; mode 3 - OR
; mode 4 - AND
; mode 5 - XOR
; mode 6 - same as 1, with transparency and collision detection by nibbles
; mode 7 - reserved
VBXE_BASE			equ	0xd600		;d600, d700 or 0 (autodetection)
VBXE_VIDEO_CONTROL	equ	VBXE_BASE+0x40
VBXE_XDL_ADR0		equ	VBXE_BASE+0x41
VBXE_XDL_ADR1		equ	VBXE_BASE+0x42
VBXE_XDL_ADR2		equ	VBXE_BASE+0x43
VBXE_CSEL			equ	VBXE_BASE+0x44
VBXE_PSEL			equ	VBXE_BASE+0x45
VBXE_CR				equ	VBXE_BASE+0x46
VBXE_CG				equ	VBXE_BASE+0x47
VBXE_CB				equ	VBXE_BASE+0x48
VBXE_COLMASK		equ	VBXE_BASE+0x49
VBXE_COLCLR			equ	VBXE_BASE+0x4a
;VBXE_MA_CPU			equ	VBXE_BASE+0x4c
;VBXE_MA_ANTIC		equ	VBXE_BASE+0x4d
;VBXE_MB_CPU			equ	VBXE_BASE+0x4e
;VBXE_MB_ANTIC		equ	VBXE_BASE+0x4f
VBXE_BL_ADR0		equ	VBXE_BASE+0x50
VBXE_BL_ADR1		equ	VBXE_BASE+0x51
VBXE_BL_ADR2		equ	VBXE_BASE+0x52
VBXE_BLITTER_START	equ	VBXE_BASE+0x53
VBXE_BLITTER_BUSY	equ	VBXE_BASE+0x53
VBXE_IRQ_CONTROL	equ	VBXE_BASE+0x54


gradientmap	equ $4000 ;xl ram

square1_lo equ $c000
square1_hi equ square1_lo+512
square2_lo equ square1_hi+512
square2_hi equ square2_lo+512

bcbstartlo equ $c800 ;in local fast ram ad
;:256	.byte <($0300+#*21)
bcbstarthi equ $c900 
;:256	.byte >($0300+#*21)
bcbsendlo equ $ca00 
;:256	.byte <($4300+#*21+20)
bcbsendhi equ $cb00
;:256	.byte >($4300+#*21+20)	
mul32	equ $cc00
lsrf0tab equ $cd00

pal equ $cf00 ;$7900-$30

;pal equ $60 ;$90 ;48 3*16

vertxs	equ $fc00 
vertys	equ $fd00 
indices equ $fe00

screencounter equ 1

;bank	equ $00
mul_fc	equ $02
miny	equ $03
dx2	equ $04 ;dx div 2
dy2	equ $05 ;dy div 2
bank	equ $06
move_flag equ $07 ;counter for fly
maxy	 equ $08
xreg_save equ $09
yreg_save equ $0a

tmp1	equ $0b ;$0c
tmp2	equ $0d ;$0e
pointer	equ $0f ;$10
temp	equ tmp1

sx1	equ $11
sx2	equ $12
cloc	equ $13 ;$14
sy1	equ $16
sy2	equ $17
screen  equ $4020
x1	equ $1f
x2	equ $21
y1	equ $25
y2	equ $27


	org y2+1
T1 	org *+2
T2 org *+2
PRODUCT org *+4


streampointer equ $a0 ;,$01
flags equ $a2
numframeverts equ $a3
polytype equ $a4
id1 equ $a5
id2 equ $a6
id3 equ $a7
vertcount equ $a8
i equ $a9
vertexperframe equ $aa
polycount equ $ab
polycol equ $4022
palflag equ $ac
timer equ $ad ;-$b2 6 bytes
screentab equ $b3 ;8
polymask equ $bc ;$bd


getbyte equ $df ;-$ff

stepy equ $7a00 ;4303
redge equ $7d00
ledge equ $7e00
spanlength equ $7d00

random	equ 53770

;	org $bf
* hline (.x -->.a, .y)


	org $1000	
;	jmp set_palette_buffer0
.proc	NMI
	bit $d40f
	bpl VBL
	jmp dummy_dli
dliv	equ *-2

VBL
	sta vbl_a+1
	stx vbl_x+1
	sty vbl_y+1

	dec cloc
	bne @+
	dec cloc+1
@	
	jsr mpt_player.play
stop	nop
	nop
	nop
	sed
	lda timer
	clc
	adc #2
	sta timer
	lda timer+1
	adc #0
	sta timer+1
	cmp #$60
	bcc @+
	lda #0
	sta timer+1
	lda timer+2
	adc #0
	sta timer+2
	cmp #$60
	bcc @+
	lda #0
	sta timer+2	
@	
	lda timer
	and #$0f
	tax
	lda digits,x
	sta text+11
	lda timer
	lsr
	lsr
	lsr
	lsr
	tax
	lda digits,x
	sta text+10
	lda timer+1
	and #$0f
	tax
	lda digits,x
	sta text+8
	lda timer+1
	lsr
	lsr
	lsr
	lsr
	tax
	lda digits,x
	sta text+7
	lda timer+2
	and #$0f
	tax
	lda digits,x
	sta text+5
	lda timer+2
	lsr
	lsr
	lsr
	lsr
	tax
	lda digits,x
	sta text+4
	cld	
skip
	.if music_flag=1
	jsr rmtplayer+3
	.endif

vbl_a	lda #0
vbl_x	ldx #0
vbl_y	ldy #0
dummy_dli rti

.endp

; init
init
.if standalone=0
	ldx #3 ;2+23+5+10
	stx bank
	sta $d500,x
	sta $f4
.endif
;copy font
	ldx #0
	stx timer
	stx timer+1
	stx timer+2
        stx $D641       ;
        stx $D642       ;
        stx $D643       ;
        stx $D647       ; disable collision detection
        stx $D654       ; disable IRQ
	lda #$21
	sta screentab
	sta screentab+4
	lda #$22
	sta screentab+1
	sta screentab+5
	lda #$23
	sta screentab+2
	sta screentab+6
	lda #$24
	sta screentab+3
	sta screentab+7
	
@
	lda fontcopy,x
	sta $3c00,x
	lda #0
	sta pal,x
	inx
	bne @-

@	lda fontcopy+256,x
	sta $3c00+256,x
	inx
	bne @-
	
	stx $d400
  	
        lda #$80		;bank 0
        sta $d65d       ;cpu-vram access window at $4000
        ldx #12
aa3:     lda xdl,x
        sta $4000,x     ; copy XDL to vram
        dex
        bpl aa3

        ldx #0
@     	lda copy_bcb,x
        sta $4100,x ;$000200 = $4200 bank #0 
        inx
        cpx #21*9
        bne @-

        ldx #0
a8:     lda cls_bcb,x
        sta $4200,x ;$000200 = $4200 bank #0 
        inx
        cpx #21*2
        bne a8

        ldx #0
@       lda slope_bcb,x
        sta $4280,x ;$000200 = $4200 bank #0 
        inx
        cpx #21
        bne @-
	
        ldx #0
@       lda copypalette_bcb,x
        sta $42c0,x ;$000200 = $4200 bank #0 
        inx
        cpx #21
        bne @-
	
	
	ldy #0	
a99	ldx #20
	sty hline_bcb+7
a9:	lda hline_bcb,x
bcbad	sta $4300,x
	dex
	bpl a9
	lda bcbad+1
	clc
	adc #21
	sta bcbad+1
	bcc @+
	inc bcbad+2
@
	
	iny
	cpy #240
	bne a99
	lda #0 ;stop blitlist
	sta $4300+20+239*21
	
	jsr init_gouraud_map
	lda #$80
	sta $d65d 
			
;  		lda:cmp:req 20      ;wait 1 frame
@		lda $d40b
		bne @-
		sei			;stop IRQ interrupts
		mva #$00 $d40e		;stop NMI interrupts	
		mva #$fe $d301		;switch off ROM to get 16k more ram	

		ldx #(getbyte_zp_end-getbyte_zp)
@		lda getbyte_zp,x
		sta getbyte,x
		dex
		bpl @-
		
;		jsr memclear
		lda #<nmi
		sta $fffa
		sta $fffe
		lda #>nmi
		sta $fffb
		sta $ffff
		cli
		lda #$40
		sta $d40e
		lda #$3c
		sta $d409

	
 	ldx #0
@
	txa
	asl
	asl
	asl
	asl
	asl
	sta mul32,x
	inx
	bne @-
 
@
 	txa
 	lsr
 	lsr
 	lsr
 	lsr
 	sta lsrf0tab,x
 	inx
 	bne @-
 
	lda #0
	tax
	sta pointer
	lda #$03
	sta pointer+1
@
	lda pointer
	sta bcbstartlo,x
	lda pointer+1
	sta bcbstarthi,x
	lda pointer
	clc
	adc #21
	sta pointer
	bcc @+
	inc pointer+1
@
	inx
	bne @-1
	
	lda #20
	sta pointer
	lda #$43
	sta pointer+1
@
	lda pointer
	sta bcbsendlo,x
	lda pointer+1
	sta bcbsendhi,x
	lda pointer
	clc
	adc #21
	sta pointer
	bcc @+
	inc pointer+1
@
	inx
	bne @-1
	


		
;	ldx #$f0 ;-18
;	lda #$01 ;-3
;	jsr fmulu
 ;$0048
	jsr generate_square_tables

;	mwa #$0002 T1
;    	mwa #$0f00 T2
;    	sec
;    	jsr multiply_16bit_unsigned
	

;    	mwa PRODUCT result2
;    	mwa PRODUCT+2 result2+2
    ; result2 should be $FA034FA4
;	lda #0
;	sta T1
;	lda #255
;	sta T1+1
;	lda #255
;	sta T2
;	sec
;	jsr multiply_s16u8

	jsr init_VBXE

	lda #$80
	sta $d65d	
	lda #0
	sta screencounter	
	jsr clear_vram
	inc screencounter
	jsr clear_vram
	inc screencounter
	jsr clear_vram
	inc screencounter
	jsr clear_vram
	inc screencounter
	
        lda #1
        sta $D640       ; enable XDL

@	lda $d40b
	bne @-

	lda #<dlistintro
	sta $d402
	lda #>dlistintro
	sta $d403
	lda #34
	sta $d400
	lda #15
	sta $d016
	
@	lda timer+1
	cmp #$05
	bcc @-
	
@	lda $d40b
	bne @-
	
	lda #<dlist
	sta $d402
	lda #>dlist
	sta $d403
	lda #33
	sta $d400
	ldx #0
	stx timer
	stx timer+1
	stx timer+2
	stx palflag
main_demo_loop
loop
	lda #$80
	sta $d65d
	ldx screencounter
	lda screentab,x
	sta $4005 ;show that screen
	lda screentab+1,x
	sta screen ;draw to this screen
;	lda palflag
;	beq @+
copypalad jsr copy_palette0
@
;clear actual screen
@       lda $d653
        bne @-      
	lda #$00
        sta $D650
        lda #$02          ;$000200 = $4200 bank #0
        sta $D651       ; blitter addr
        lda #$00          ;
        sta $D652
	lda #$80
	sta $d65d

    	ldx screencounter
    	lda screentab+2,x
   	sta $4208 ;clr_bcb which screen
	lda #0
	sta $d65d
    	lda #1
        sta $D653
	jsr parse_data
	inc screencounter
	lda screencounter
	and #3
	sta screencounter
continue2
	jmp loop

.proc parse_data
 	jsr getbyte
	sta flags
;TRACE "x1 = %d" dw(x1+1)	
;	and #1
;	bne @+
;	jsr clear_vram
@
;check for palette
;	lda flags
	and #2
	beq no_palette
setpalettead jsr set_palette_buffer0
no_palette
	lda flags
	and #4 ;is indexed data?
	beq no_indexed_mode
	jmp indexed_mode
no_indexed_mode	
do_polys2
	jsr getbyte
	sta polytype
	tax
	lda lsrf0tab,x
	ldy #$80
	sty $d65d
;	ora #$80
	sta polycol
	lda #0
	sta $d65d
	txa
	and #$0f
	sta vertcount

	txa
	cmp #$ff ;end of frame
	bne @+
	rts
@	
	cmp #$fd ;end of file
	bne @+
	lda #$00
	sta $f6+1
	lda #$c0
	sta $f7+1
	lda #2 ;1 due to auto inc!!! 1+23+5+10
	sta bank
	lda #$4c
	sta nmi.stop
	lda #<blinking
	sta nmi.stop+1
	lda #>blinking
	sta nmi.stop+2
	rts
@
	cmp #$fe ;end of 64k
	bne @+
	lda #$00
	sta $f6+1
	lda #$c0
	sta $f7+1
	rts
@
	lda #1
	sta maxy
	lda #200
	sta miny

	ldx vertcount
	jsr getbyte
	sta vertxs,x
	sta vertxs
	jsr getbyte
	sta vertys,x
	sta vertys
	
	ldx #1
do_verts2
	jsr getbyte
	sta vertxs,x
	jsr getbyte
	sta vertys,x
	inx
	cpx vertcount
	bne do_verts2

	lda #0
	sta do_verts3+1
;draw poly
do_verts3 ldx #0
	lda vertxs,x
	sta sx1 ;x1+1
	lda vertys,x
	sta sy1 ;y1+1
	cmp miny
	bcs @+
	sta miny
@
	cmp maxy
	bcc @+
	sta maxy
@
	lda vertxs+1,x
	sta sx2 ;x2+1
	lda vertys+1,x
	sta sy2 ;y2+1
	jsr calc_slope ;poly
	inc do_verts3+1
	dec vertcount
	bne do_verts3
	jsr draw_poly ;render_scene
@	jmp do_polys2 
.endp

indexed_mode
	jsr getbyte
	sta numframeverts ;how many vertices per frame
;now read the verticesx and verticesy
	ldy #0 ;numframeverts
@	jsr getbyte
	sta vertxs,y
	jsr getbyte
	sta vertys,y
	iny
	cpy numframeverts
	bne @-
	
do_polys
	jsr getbyte
	sta polytype
	tax
	lda lsrf0tab,x
;	and #$f0
;	lsr
;	lsr
;	lsr
;	lsr
	ldy #$80
        sty $d65d       
	sta polycol
	ldy #0
	sty $d65d
	txa
	and #$0f
	sta vertcount ;how many lines 0-15

	lda polytype
	cmp #$ff ;end of frame
	bne @+
	rts
@	
	cmp #$fd ;end of file wrap
	bne @+
	lda #$00
	sta $f6+1
	lda #$c0
	sta $f7+1
	lda #2 ;1 due to auto inc!!! 1+23+5+10
	sta bank
	lda #$4c
	sta nmi.stop
	lda #<blinking
	sta nmi.stop+1
	lda #>blinking
	sta nmi.stop+2
	rts
@
	cmp #$fe ;end of 64k
	bne @+
	lda #$00
	sta $f6+1
	lda #$c0
	sta $f7+1
;	inc bank
;	ldx bank
;	sta $d500,x
	rts
@
	lda #1
	sta maxy
	lda #200
	sta miny

	jsr getbyte ;first id
	ldx vertcount
	sta indices,x
	sta indices

	ldx #1
@
	jsr getbyte
	sta indices,x
	inx
	cpx vertcount
	bne @-
	
	lda #0
	sta i		
do_verts ;draw poly
	ldx i
	ldy indices,x
	lda vertxs,y
	sta sx1 ;x1+1
	lda vertys,y
	sta sy1 ;y1+1
	cmp miny
	bcs @+
	sta miny
@
	cmp maxy
	bcc @+
	sta maxy
@

	ldy indices+1,x
	lda vertxs,y
	sta sx2 ;x2+1
	lda vertys,y
	sta sy2 ;y2+1

	jsr calc_slope ;poly ;_dda ;line x1,y1 to x2,y2

	inc i
	lda i
	cmp vertcount
	bne do_verts
	jsr draw_poly ;fill poly
	jmp do_polys 

.proc set_palette_buffer0   ;set palette buffer 0
	lda #$80
	sta $d65d
	lda #1
	sta VBXE_PSEL
	sta palflag
	jsr getbyte 
	sta polymask ;read short... ;)
	tay
	jsr getbyte
	sta polymask+1 ;each bit in palmask defines if color needs to be set
@		
.macro setpal register buffer
	jsr getbyte ;xx xx xx xx xx R2 R1 R0  xx G2 G1 G0 xx B2 B1 B0
	and #7
	sta pal+:register+:buffer*48 ;R
	jsr getbyte ;lo
	tax
	and #$70
	lsr
	lsr
	lsr
	lsr
	sta pal+16+:register+:buffer*48 ;G
	txa
	and #$07
	sta pal+32+:register+:buffer*48 ;B
.endm
	tya
	and #128
	beq @+
	setpal 0 0
@	
	tya
	and #64
	beq @+
	setpal 1 0
@	
	tya
	and #32
	beq @+
	setpal 2 0
@	
	tya
	and #16
	beq @+
	setpal 3 0
@	
	tya
	and #8
	beq @+
	setpal 4 0
@	
	tya
	and #4
	beq @+
	setpal 5 0
@	
	tya
	and #2
	beq @+
	setpal 6 0
@	
	tya
	and #1
	beq @+
	setpal 7 0

@	
	lda polymask+1
	tay	
	and #128
	beq @+
	setpal 8 0
@	
	tya
	and #64
	beq @+
	setpal 9 0
@	
	tya
	and #32
	beq @+
	setpal 10 0
@	
	tya
	and #16
	beq @+
	setpal 11 0
@	
	tya
	and #8
	beq @+
	setpal 12 0
@	
	tya
	and #4
	beq @+
	setpal 13 0
@	
	tya
	and #2
	beq @+
	setpal 14 0
@	
	tya
	and #1
	beq @+
	setpal 15 0
@
;	lda #0
;	sta $d65d
	rts

;[10:46:28] axis/oxyron (oxy): just copy pal
;[10:46:32] axis/oxyron (oxy): once per frame
;[10:46:38] axis/oxyron (oxy): pal1, pal2, pal3
;[10:47:03] Karolj Nadj: yeah but... pal2 contains only delta colors to pal1
;[10:47:19] axis/oxyron (oxy): you always build pal1 out of the deltas
;[10:47:23] axis/oxyron (oxy): copy 1 to 2
;[10:47:25] axis/oxyron (oxy): copy 2 to 3
;[10:47:25] axis/oxyron (oxy): copy 3 to 4

;[10:47:28] axis/oxyron (oxy): and use 4 for rendering
;[10:47:35] axis/oxyron (oxy): e.g.


.endp

.proc copy_palette0
;@	lda $d653
;	bne @-
;
;	lda #$c0
;	sta $d650
;	lda #$02
;	sta $d651
;	lda #$00
;	sta $d652
;	lda #1
;	sta $d653
;	
;	lda #$80
;	sta $d65d
	ldx #15
@
	stx VBXE_CSEL
	ldy pal+0*48,x
	lda mul32,y
	sta VBXE_CR
	ldy pal+16+0*48,x
	lda mul32,y
	sta VBXE_CG
	ldy pal+32+0*48,x
	lda mul32,y
	sta VBXE_CB
	dex
	bpl @-
;	lda #0
;	sta $d65d
	rts
.endp

;works in screen coords

* poly (.y, .a, x2, y2, x3, y3)
ttemp .byte 0

.proc poly
	;jmp render_scene
	lda #$80
	sta $d65d
_dopoly	
;	lda x1+1
;	sta sx1
;	lda y1+1
;	sta sy1
;	lda x2+1
;	sta sx2
;	lda y2+1
;	sta sy2
	jsr calc_slope
	lda #0
	sta $d65d
	rts
.endp
.proc draw_poly	
;sanity check
;debug spanlength calc
	lda #$80
	sta $d65d
@        lda $d653
       bne @-      
	lda #8
ffff	sta $cfff

.if blitter_only=0
	ldy miny
@
	lda redge,y 
	sec
	sbc ledge,y
	bcs sk
	lda #0
sk
	sta redge,y
	iny
	cpy maxy
	bcc @-
.endif
;add+EOR#$ff = sub = spanlength
;fill in tables into scanedge blittlist
;	lda #$80
;	sta $d65d

        lda #$01          ;
        sta $D651
	lda #0
	sta $d650
	sta $d652
	lda #1
	sta $d653

	
;blit poly_face	
;	dey
	ldy maxy
	dey
	lda bcbsendlo,y
	sta fff+1
	sta ffff+1
	lda bcbsendhi,y
	sta fff+2
	sta ffff+2
;	
;	ldy miny
;_drwply		
;	lda redge,y
;	sec
;	sbc ledge,y
;	bcs _drw3 
;	bpl _drw3
;	lda #0
;_drw3	sta $430c ;sizex 	
;@	lda _drw3+1
;	clc
;	adc #21
;	sta _drw3+1
;	bcc _drw2
;	inc _drw3+2
;_drw2	
;	iny 
;	cpy maxy
;	bne _drwply
;	lda #$43
;	sta _drw3+2


	lda #0 ;stop flag
fff	sta $ffff

@	lda $d653
	bne @-

        lda #$00          ;
        sta $D652
	ldy miny
	lda bcbstartlo,y
	sta $d650
	lda bcbstarthi,y
	sta $d651

;blit face

	lda #1
	sta $d653

;@	lda $d653
;	bne @-
;reset endflag	
;drawmode lda $4021
polyexit 
	lda #0
	sta $d65d	
	rts
.endp

.proc generate_square_tables
      ; generate f(x)=int(x*x/4)
      ldx #$00
      txa
      .byte $c9
lb1   tya
      adc #$00
ml1   sta square1_hi,x
      tay
      cmp #$40
      txa
      ror 
ml9   adc #$00
      sta ml9+1
      inx
ml0   sta square1_lo,x
      bne lb1
      inc ml0+2
      inc ml1+2
      clc
      iny
      bne lb1
      ; generate f(x)=int((x-255)*(x-255)/4)
      ldx #$00
      ldy #$ff
ml2   lda square1_hi+1,x
      sta square2_hi+$100,x
      lda square1_hi,x
      sta square2_hi,y
      lda square1_lo+1,x
      sta square2_lo+$100,x
      lda square1_lo,x
      sta square2_lo,y
      dey
      inx
      bne ml2
      rts
.endp      

multiply_16x8bit_unsigned
                ; <T1 * <T2 = AAaa
                ; >T1 * <T2 = CCcc
                ;
                ;       AAaa
                ; +   CCcc
                ; ----------
                ;   PRODUCT!

                ; Setup T1 if changed
                bcc m16x8u_setup_done
                    lda T1+0
                    sta sm1a16x8+1
                    sta sm3a16x8+1
                    eor #$ff
                    sta sm2a16x8+1
                    sta sm4a16x8+1
                    lda T1+1
                    sta sm1b16x8+1
                    sta sm3b16x8+1
                    eor #$ff
                    sta sm2b16x8+1
                    sta sm4b16x8+1
m16x8u_setup_done

                ; Perform <T1 * <T2 = AAaa
                ldx T2+0
                sec
sm1a16x8        lda square1_lo,x
sm2a16x8        sbc square2_lo,x
                sta PRODUCT+0
sm3a16x8        lda square1_hi,x
sm4a16x8        sbc square2_hi,x
                sta _AA16x8+1

                ; Perform >T1_hi * <T2 = CCcc
                sec
sm1b16x8        lda square1_lo,x
sm2b16x8        sbc square2_lo,x
                sta _cc16x8+1
sm3b16x8        lda square1_hi,x
sm4b16x8        sbc square2_hi,x
                sta PRODUCT+2

                ; Add the separate multiplications together
                clc
_AA16x8         lda #0
_cc16x8         adc #0
                sta PRODUCT+1
                scc:inc PRODUCT+2

                rts
multiply_s16u8

                jsr multiply_16x8bit_unsigned

                ; Apply sign (See C=Hacking16 for details).
                lda T1+1
                bpl ms16u8_signfix1_done
                    sec
                    lda PRODUCT+2
                    sbc T2+0
                    sta PRODUCT+2
ms16u8_signfix1_done

                rts

multiply_u16s8
		lda t2
		bmi mulneg
		sec
		jsr multiply_16x8bit_unsigned
		rts			
mulneg          
		lda #0 ;neg t2
		sec
		sbc t2
		sta t2
		sec
		jsr multiply_16x8bit_unsigned
                ; Apply sign (See C=Hacking16 for details).
		lda #0
		sec
		sbc product+1
		sta product+1
		lda #0
		sbc product+2
		sta product+2            	    
mu16s8_signfix1_done

                rts

      


xdl:
        ;.byte $22 ;repeat gfx 
        ;.byte $10 ;
        ;.byte 1      
        .byte $72 ;repeat+adr+gfx
        .byte $88 ;stop
        .byte 199     ;RPTL
;screenram
vramadr	.long $210000 ;OVADR 
	.byte <256,>256  ;ystep of display          
        .byte $10,$c0   ;OVATT

;copies edge into bcb
copy_bcb
;vram adress for double buffer
		.long $000020 ;source
		.word 0 ;source step y
		.byte 0 ;source step x
		.long $000308 ;destination adress
		.word 21 ;dest. step y
		.byte 0 ;dest step x
		.word 0 ;size x
		.byte 199	;size y
		.byte $ff 	;and
	        .byte $00     ; XOR
	        .byte 0       ;  collision AND
 	        .byte $00       ; zoom
		.byte 0       ; pattern
	        .byte 8	       ; control
;polycolor
		.long $000022 ;source color right edge 
		.word 0 ;source step y
		.byte 0 ;source step x
		.long $000310 ;destination adress
		.word 0 ;dest. step y
		.byte 21 ;dest step x
		.word 199 ;size x
		.byte 0	;size y
		.byte $ff 	;and
	        .byte $00     ; XOR
	        .byte 0       ;  collision AND
 	        .byte $00       ; zoom
		.byte 0       ; pattern
	        .byte 8	       ; control

		.long $003e00 ;source adress left edge
		.word 0 ;source step y
		.byte 1 ;source step x
		.long $000306 ;destination adress
		.word 0 ;dest. step y
		.byte 21 ;dest step x
		.word 239 ;size x
		.byte 0	;size y
		.byte $ff 	;and
	        .byte $00     ; XOR
	        .byte 0       ;  collision AND
 	        .byte $00       ; zoom
		.byte 0       ; pattern
	        .byte 8	       ; control
.if blitter_only=1
;redge equ $7d00
;ledge equ $7e00
;spanlength = left AND #$ff EOR #$ff+right into right+1
		.long $003e00 ;source 
		.word 1 ;source step y
		.byte 0 ;source step x
		.long $003d00 ;destination adress
		.word 1 ;dest. step y
		.byte 0 ;dest step x
		.word 0 ;size x
		.byte 199	;size y
		.byte $ff 	;and
	        .byte $ff     ; XOR
	        .byte 0       ;  collision AND
 	        .byte $00       ; zoom
		.byte 0       ; pattern
	        .byte 10       ; control

		.long $000000 ;source
		.word 0 ;source step y
		.byte 0 ;source step x
		.long $003d00 ;destination adress
		.word 1 ;dest. step y
		.byte 0 ;dest step x
		.word 0 ;size x
		.byte 199	;size y
		.byte $00 	;and
corrval	        .byte $01 ;     ; XOR
	        .byte 0       ;  collision AND
 	        .byte $00       ; zoom
		.byte 0       ; pattern
	        .byte 10       ; control
.endif
;spanlength
		.long $003d00 ;source length edge
		.word 0 ;source step y
		.byte 1 ;source step x
		.long $00030c ;destination adress
		.word 0 ;dest. step y
		.byte 21 ;dest step x
		.word 199 ;size x
		.byte 0	;size y
		.byte $ff 	;and
	        .byte $00     ; XOR
	        .byte 0       ;  collision AND
 	        .byte $00       ; zoom
		.byte 0       ; pattern
	        .byte 0	       ; control


		.long $003c00 ;source color start
		.word 0 ;source step y
		.byte 1 ;source step x
		.long $000301 ;destination adress
		.word 0 ;dest. step y
		.byte 21 ;dest step x
		.word 199 ;size x
		.byte 0	;size y
		.byte $ff 	;and
	        .byte $00     ; XOR
	        .byte 0       ;  collision AND
 	        .byte $00       ; zoom
		.byte 0       ; pattern
	        .byte 8	       ; control
;stepy value
		.long $003a00 ;source step value
		.word 0 ;source step y
		.byte 1 ;source step x
		.long $000303 ;destination adress
		.word 21 ;dest. step y
		.byte 1 ;dest step x
		.word 2-1 ;size x
		.byte 199	;size y
		.byte $ff 	;and
	        .byte $00     ; XOR
	        .byte 0       ;  collision AND
 	        .byte $00       ; zoom
		.byte 0       ; pattern
	        .byte 0	       ; control
	
;copypalette 0,30,60,90,c0
copypalette_bcb	.long pal+4*48-$4000 ;$003f90 ;source
		.word -48 ;source step y
		.byte 1 ;source step x
		.long pal+5*48-$4000 ;$003fc0 ;destination adress
		.word -48 ;dest. step y
		.byte 1 ;dest step x
		.word 47 ;size x
		.byte 4	;size y
		.byte $ff 	;and
	        .byte $00     ; XOR
	        .byte 0       ;  collision AND
 	        .byte $00       ; zoom
		.byte 0       ; pattern
	        .byte 0	       ; control

cls_bcb: 
		.long $000000 ;source adress ;$0400 texture $5000
		.word 0 ;source step y
		.byte 0 ;source step x
		.long $040000 ;destination adress
		.word 256 ;dest. step y
		.byte 1
		.word 255 ;size x
		.byte 199	;size y
		.byte $00 	;and
	        .byte $00     ; XOR
	        .byte 0       ;  collision AND
 	        .byte $00       ; zoom
		.byte $00       ; pattern
	        .byte 0; control

;copy $a000-$bfff to $8000-$9fff 
		.long $000000 ;source adress ;$0400 texture $5000
		.word 0 ;source step y
		.byte 0 ;source step x
		.long $040000 ;destination adress
		.word 256 ;dest. step y
		.byte 1
		.word 255 ;size x
		.byte 31	;size y
		.byte $00 	;and
	        .byte $00     ; XOR
	        .byte 0       ;  collision AND
 	        .byte $00       ; zoom
		.byte $00       ; pattern
	        .byte 0; control

;calc slope
slope_bcb	.long $070000 ;source length edge
		.word $0000 ;source step y = m
 		.byte 0 ;source step x
		.long $003d00 ;right edge or left
		.word 1 ;dest. step y
		.byte 0 ;dest step x
		.word 0 ;size x ;only 1 byte copy
		.byte 199	;size y
		.byte $ff 	;and
	        .byte $00     ; XOR
	        .byte 0       ;  collision AND
 	        .byte $00       ; zoom
		.byte 0       ; pattern
	        .byte 0	       ; control

hline_bcb: 
		.long $074000 ;source adress
		.word 0 ;source step y
		.byte 0 ;source step x
		.long $010000+0*256 ;destination adress
		.word 0 ;0 ;dest. step y
		.byte 1 ;-1
		.word 0 ;size x
		.byte 0	;size y
		.byte $00 	;and
	        .byte $ff     ; XOR
	        .byte 0       ;  collision AND
 	        .byte $00       ; zoom
		.byte 0       ; pattern
	        .byte 8 ;2	       ; control


fastexit rts
.proc calc_slope	
;TO DO: WORK WITH 16bit coords here!!! see POLY
	lda $d653 ;wait blitter
	bne calc_slope
	lda #$80
	sta $d65d
	lda #1
	sta $4289
	lda #0
	sta $428a
	lda #$3e ;left edge buffer 
	sta $4287


	lda sy2
	cmp sy1 
	beq fastexit
	bcs @+ ;swap needed?
	ldx sx1
	lda sx2
	sta sx1
	stx sx2
	ldx sy1
	lda sy2
	sta sy1
	stx sy2
	lda #$3d ;right edge buffer 
	sta $4287

@	
	lda sx1
	sta $4281 ;start x value of edge = startpos in array (*256 as 8.8 format)
;table entry point is at sy1
	ldx sy1
	stx $4286 ;low byte of edge table starting at sy1 = fill array at sy1 to sy2	

	lda sx1
	cmp sx2
	bcs signed_version ;>=
@	
	lda sx2 
	sec
	sbc sx1
	sta T2
;	lda #0
;	sta T1+1

	lda sy2
	sec
	sbc sy1 
	tax
	lda recitab32768,x
	sta T1
	lda recitab32768+256,x
	sta T1+1
	dex
	stx $428e ;edge length = blit size y

	sec
	;jsr multiply_16bit_unsigned ;dx/dy = dx * 1/dy
	jsr multiply_16x8bit_unsigned

	;jsr multiply_s16u8
	;asl product+1 ;shift up *2
	;rol product+2
	
blitprep 
;check if slope>$1000 then slope=$1000
;check if slope>$-1000 then slope=-$1000 = $1fff	
;$f000 = -4096 ;in blitter 12bit step (13bits!!!)
;$f001 = -4095
;$ffff = -1
;$0001 = +1
;$0fff = +4095
;	lda product+3
;	bpl @+
;;minus step $2xxx
;	lda product+2
;	cmp #$f0
;	bcs do_blit
;	lda #$f0
;	sta $4284
;	lda #0
;	sta $4283
;	beq do_blit
	

	lda product+1
	sta $4283
	lda product+2
	sta $4284
	
@	lda product+2
	cmp #$0f
	bcc do_blit
	lda #$0f
	sta $4284
	lda #$ff
	sta $4283		

;start blit
do_blit
	lda #128
        sta $D650
        lda #$02          ;$000280 = $4280 bank #0
        sta $D651       ; blitter addr
        lda #$00          ;
        sta $D652
    	lda #1
        sta $D653       ; start blitter (LERP)
;	jsr waitblt
exit	;brk
	lda #0
	sta $d65d
	rts

signed_version
.local
	lda #$ff
	sta $4289
	sta $428a

	lda sx2
	sta $4281 ;start x value of edge = startpos in array (*256 as 8.8 format)
;table entry point is at sy1
	lda sy2
	sec
	sbc #1
	sta $4286 ;low byte of edge table starting at sy1 = fill array at sy2 to sy1	

	lda sx1 
	sec
	sbc sx2
	sta T2
;	lda #0
;	sta T1+1
;;##TRACE "sx1= %02x sx2= %02x sx1-sx2= %04x" db(sx1) db(sx2) dw(t1)

	lda sy2
	sec
	sbc sy1 ;delta y in 16bit signed but always >0
	tax
	lda recitab32768,x
	sta T1
	lda recitab32768+256,x
	sta T1+1
	dex
	stx $428e ;edge length = blit size y
	sec
	;jsr multiply_16bit_unsigned ;dx/dy = dx * 1/dy
	jsr multiply_16x8bit_unsigned

;;##TRACE "sy1= %02x sy2= %02x sy2-sy1= %04x" db(sy1) db(sy2) dw(product+1)
	
blitprep 
;check if slope>$1000 then slope=$1000
;check if slope>$-1000 then slope=-$1000 = $1fff	
;$f000 = -4096 ;in blitter 12bit step (13bits!!!)
;$f001 = -4095
;$ffff = -1
;$0001 = +1
;$0fff = +4095

;	lda product+3
;	bpl @+
;;minus step $2xxx
;	lda product+2
;	cmp #$f0
;	bcs do_blit
;	lda #$f0
;	sta $4284
;	lda #0
;	sta $4283
;	beq do_blit
	lda product+1
	sta $4283
	lda product+2
	sta $4284
	
@	lda product+2
	cmp #$0f
	bcc do_blit
	lda #$0f
	sta $4284
	lda #$ff
	sta $4283		


;start blit
do_blit
@        lda $d653
       bne @-      

	lda #128
        sta $D650
        lda #$02          ;$000280 = $4280 bank #0
        sta $D651       ; blitter addr
        lda #$00          ;
        sta $D652
    	lda #1
        sta $D653       ; start blitter (draw stars)
;	jsr waitblt
exit	;brk
	lda #0
	sta $d65d
	rts
.endl

;calc slope
;slope_bcb	.long $07x100 ;source length edge
;		.word $0000 ;source step y = m
; 		.byte 0 ;source step x
;		.long $003e00 ;left edge
;		.word 1 ;dest. step y
;		.byte 0 ;dest step x
;		.word 0 ;size x ;only 1 byte copy
;		.byte 255	;size y
;		.byte $ff 	;and
;	        .byte $00     ; XOR
;	        .byte 0       ;  collision AND
; 	        .byte $00       ; zoom
;		.byte 0       ; pattern
;	        .byte 0	       ; control
	
.endp

fastexitc	rts


;calc slope
;slope_bcb	.long $07x100 ;source length edge
;		.word $0000 ;source step y = m
; 		.byte 0 ;source step x
;		.long $003e00 ;left edge
;		.word 1 ;dest. step y
;		.byte 0 ;dest step x
;		.word 0 ;size x ;only 1 byte copy
;		.byte 255	;size y
;		.byte $ff 	;and
;	        .byte $00     ; XOR
;	        .byte 0       ;  collision AND
; 	        .byte $00       ; zoom
;		.byte 0       ; pattern
;	        .byte 0	       ; control
	


init_VBXE:
		ldx	#1
		stx	VBXE_PSEL
		ldx	#0
		stx	VBXE_CSEL ;which colour # to change
		stx VBXE_CR
		stx VBXE_CG
		stx VBXE_CB
		rts	
		
waitblt:
        lda $D653       ; wait until not-busy
        bne waitblt
        rts

.proc blinking
	inc blink
	lda blink
	and #$0f
	sta $d016
	jmp nmi.skip
.endp
blink 	.byte 0
clear_vram:
cccc	      
	jsr waitblt
	lda #$00
        sta $D650
        lda #$02          ;$000200 = $4200 bank #0
        sta $D651       ; blitter addr
        lda #$00          ;
        sta $D652
	lda #$80
	sta $d65d
    	ldx screencounter
    	lda screentab,x
  	sta screen
   	sta $4208 ;clr_bcb which screen
	lda #0
	sta $d65d
    	lda #1
        sta $D653       ; start blitter (draw stars)
	jsr waitblt
	rts
	
init_gouraud_map
.local
	lda #$dc		;bank 1
        sta $d65d       ;cpu-vram access window at $4000, $70000
	ldy #0
@	ldx #0
@	tya
ad	sta gradientmap,x
	inx 
	bne @-
	inc ad+2
	iny
	cpy #$40
	bne @-1

	lda #$dd		;bank 2
        sta $d65d       ;$008000
	
	ldy #$40
@	ldx #0
@	tya
ad2	sta gradientmap,x
	inx 
	bne @-
	inc ad2+2
	iny
	cpy #$80
	bne @-1

	lda #$de		;bank 3
        sta $d65d       ;cpu-vram access window at $4000

	ldy #128
@	ldx #0
@	tya
ad3	sta gradientmap,x
	inx 
	bne @-
	inc ad3+2
	iny
	cpy #$c0
	bne @-1

	lda #$df		;bank 1
        sta $d65d       ;cpu-vram access window at $4000

	ldy #$c0
@	ldx #0
@	tya
ad4	sta gradientmap,x
	inx 
	bne @-
	inc ad4+2
	iny
	bne @-1
.endl
	jmp init_end
;reverse tabl
.local
	lda #$dc-4		;bank 1
        sta $d65d       ;cpu-vram access window at $4000, $70000
	ldy #0
@	ldx #0
@	tya
;	eor #$ff
;	clc
;	adc #1
ad	sta gradientmap,x
	inx 
	bne @-
	inc ad+2
	iny
	cpy #$40
	bne @-1
	;jmp init_end
		
	lda #$dd-4		;bank 2
        sta $d65d       ;$008000
	
	ldy #$40
@	ldx #0
@	tya
;	eor #$ff
;	clc
;	adc #1
ad2	sta gradientmap,x
	inx 
	bne @-
	inc ad2+2
	iny
	cpy #$80
	bne @-1

	lda #$de-4		;bank 3
        sta $d65d       ;cpu-vram access window at $4000

	ldy #128
@	ldx #0
@	tya
;	eor #$ff
;	clc
;	adc #1
ad3	sta gradientmap,x
	inx 
	bne @-
	inc ad3+2
	iny
	cpy #$c0
	bne @-1

	lda #$df-4		;bank 1
        sta $d65d       ;cpu-vram access window at $4000

	ldy #$c0
@	ldx #0
@	tya
;	eor #$ff
;	clc
;	adc #1
ad4	sta gradientmap,x
	inx 
	bne @-
	inc ad4+2
	iny
	bne @-1
.endl

;
init_end
	lda #$80
	sta $d65d

	rts
dlist
:26	.byte $70
	.byte $46
	.word text
	.byte $41
	.word dlist
dlistintro
	.byte $70,$70,$70,$47
	.word text2,$40
:8	.byte 7,$70
	.byte $41
	.word dlistintro
.if standalone=1

.proc getbyte_zp
	lda $f7+1
	cmp #$c0
	bne @+
	lda #$00
	sta $f6+1
	lda #$30 ;bb5c
	sta $f7+1
	inc bank
	lda bank
	sta $f4
	sta $d500 ;$f4!!!
@
	lda streamdata ;$bb5c ;streamdata
	inc $f6+1
	bne @+
	inc $f7+1
@
	rts
.endp
.else
.proc getbyte_zp
	lda $f7+1
	cmp #$c0
	bne @+
	lda #$00
	sta $f6+1
	lda #$a0 ;bb5c
	sta $f7+1
	inc bank
	lda bank
	sta $f4
	sta $d500 ;$f4!!!
@
	lda streamdata ;$bb5c ;streamdata
	inc $f6+1
	bne @+
	inc $f7+1
@
	rts
.endp
.endif
getbyte_zp_end

       icl 'mpt_player.asm'



text 	dta d"    00:00:00     "	
digits 	dta d"0123456789"

fontcopy ins "antic.chr",0,512
text2
	.byte d" HEAVEN + AXIS HAVE "
	.byte d" NEW COMPO FOR YOU! "
	.byte d"   ST-NICCC COMPO   "
	.byte d"--------------------"
	.byte d"WHO RENDERS FASTER? "
	.byte d"                    "
	.byte d"WE USE 1:1 ST DATA! "
	.byte d"     MORE INFO      "
	.byte d" WWW.ARSANTICA.COM  "
	
	.align $100
;recitab ins "recitab4.dat" ;.dat" ;prg",2
recitab32768 ;ins "recitab32768.dat"
	ins "recitab65536.dat"

	.align $100 ;$player+$500
msx	;equ $4000

;	mpt_relocator 'intro_bb_2.mpt' , msx
	mpt_relocator 'garnek2.mpt' , msx

	org msx
	.sav [6] ?length


;	.align $100
;	org $2000

 


.if standalone=1
	org $4000
streamdata
;	ins "scene1.bin",$30000,$8000 ;$40e00,$9000
	ins "scene1.bin",0*65536+$9000,$7000 ;$40e00,$9000
	run init
.else
streamdata = $a000

.endif
	
	
	opt l-
	icl 'mpt_relocator.mac'