setlocal

set MADS=bin\mads.exe

set FILE=ST-NICCC-Blitter
%MADS% %FILE%.asm -d:standalone=0 -t:%FILE%.lab -l:%FILE%.lst -o:%FILE%.xex
if ERRORLEVEL 1 goto :mads_error

set FILE=ST-NICCC-Blitter-Atarimax
%MADS% %FILE%.asm -t:%FILE%.lab -l:%FILE%.lst -o:%FILE%.rom
if ERRORLEVEL 1 goto :mads_error

call :convert
start %FILE%.car
goto :eof

:convert
 echo Converting %FILE%
 java -jar bin\AtariRomMaker.jar -load:"%FILE%.rom" -convertToCAR:42 -save:"%FILE%.car"
goto :eof


:mads_error
echo ERROR: MADS compilation errors occurred. Check error messages above.
pause
exit
